Index: uspace/srv/hid/input/ctl/kbdev.c
===================================================================
--- uspace/srv/hid/input/ctl/kbdev.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/hid/input/ctl/kbdev.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -68,5 +68,5 @@
 	/** Link to generic keyboard device */
 	kbd_dev_t *kbd_dev;
-	
+
 	/** Session with kbdev device */
 	async_sess_t *sess;
@@ -75,8 +75,10 @@
 static kbdev_t *kbdev_new(kbd_dev_t *kdev)
 {
-	kbdev_t *kbdev = calloc(1, sizeof(kbdev_t));
+	kbdev_t *kbdev;
+
+	kbdev = calloc(1, sizeof(kbdev_t));
 	if (kbdev == NULL)
 		return NULL;
-	
+
 	kbdev->kbd_dev = kdev;
 
@@ -88,5 +90,4 @@
 	if (kbdev->sess != NULL)
 		async_hangup(kbdev->sess);
-	
 	free(kbdev);
 }
@@ -94,31 +95,35 @@
 static int kbdev_ctl_init(kbd_dev_t *kdev)
 {
-	async_sess_t *sess = loc_service_connect(EXCHANGE_SERIALIZE,
-	    kdev->svc_id, 0);
+	async_sess_t *sess;
+	async_exch_t *exch;
+	kbdev_t *kbdev;
+	int rc;
+
+	sess = loc_service_connect(EXCHANGE_SERIALIZE, kdev->svc_id, 0);
 	if (sess == NULL) {
 		printf("%s: Failed starting session with '%s.'\n", NAME,
 		    kdev->svc_name);
-		return ENOENT;
+		return -1;
 	}
-	
-	kbdev_t *kbdev = kbdev_new(kdev);
+
+	kbdev = kbdev_new(kdev);
 	if (kbdev == NULL) {
 		printf("%s: Failed allocating device structure for '%s'.\n",
 		    NAME, kdev->svc_name);
 		async_hangup(sess);
-		return ENOMEM;
+		return -1;
 	}
-	
+
 	kbdev->sess = sess;
-	
-	async_exch_t *exch = async_exchange_begin(sess);
+
+	exch = async_exchange_begin(sess);
 	if (exch == NULL) {
 		printf("%s: Failed starting exchange with '%s'.\n", NAME,
 		    kdev->svc_name);
 		kbdev_destroy(kbdev);
-		return ENOENT;
+		return -1;
 	}
-	
-	int rc = async_connect_to_me(exch, 0, 0, 0, kbdev_callback_conn, kbdev);
+
+	rc = async_connect_to_me(exch, 0, 0, 0, kbdev_callback_conn, kbdev);
 	if (rc != EOK) {
 		printf("%s: Failed creating callback connection from '%s'.\n",
@@ -126,9 +131,9 @@
 		async_exchange_end(exch);
 		kbdev_destroy(kbdev);
-		return rc;
+		return -1;
 	}
-	
+
 	async_exchange_end(exch);
-	
+
 	kdev->ctl_private = (void *) kbdev;
 	return 0;
@@ -137,9 +142,13 @@
 static void kbdev_ctl_set_ind(kbd_dev_t *kdev, unsigned mods)
 {
-	async_sess_t *sess = ((kbdev_t *) kdev->ctl_private)->sess;
-	async_exch_t *exch = async_exchange_begin(sess);
+	async_sess_t *sess;
+	async_exch_t *exch;
+
+	sess = ((kbdev_t *) kdev->ctl_private)->sess;
+
+	exch = async_exchange_begin(sess);
 	if (!exch)
 		return;
-	
+
 	async_msg_1(exch, KBDEV_SET_IND, mods);
 	async_exchange_end(exch);
Index: uspace/srv/hid/input/generic/input.c
===================================================================
--- uspace/srv/hid/input/generic/input.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/hid/input/generic/input.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -662,7 +662,7 @@
 	async_set_client_connection(client_connection);
 	int rc = loc_server_register(NAME);
-	if (rc != EOK) {
-		printf("%s: Unable to register server\n", NAME);
-		return rc;
+	if (rc < 0) {
+		printf("%s: Unable to register server (%d)\n", NAME, rc);
+		return -1;
 	}
 	
@@ -671,8 +671,7 @@
 	
 	service_id_t service_id;
-	rc = loc_service_register(kbd, &service_id);
-	if (rc != EOK) {
+	if (loc_service_register(kbd, &service_id) != EOK) {
 		printf("%s: Unable to register service %s\n", NAME, kbd);
-		return rc;
+		return -1;
 	}
 	
Index: uspace/srv/hid/input/port/adb.c
===================================================================
--- uspace/srv/hid/input/port/adb.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/hid/input/port/adb.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -65,9 +65,12 @@
 static int adb_port_init(kbd_dev_t *kdev)
 {
+	const char *dev = "adb/kbd";
+	service_id_t service_id;
+	async_exch_t *exch;
+	int rc;
+	
 	kbd_dev = kdev;
 	
-	const char *dev = "adb/kbd";
-	service_id_t service_id;
-	int rc = loc_service_get_id(dev, &service_id, 0);
+	rc = loc_service_get_id(dev, &service_id, 0);
 	if (rc != EOK)
 		return rc;
@@ -79,5 +82,5 @@
 	}
 	
-	async_exch_t *exch = async_exchange_begin(dev_sess);
+	exch = async_exchange_begin(dev_sess);
 	if (exch == NULL) {
 		printf("%s: Failed starting exchange with device\n", NAME);
@@ -86,4 +89,5 @@
 	}
 	
+	/* NB: The callback connection is slotted for removal */
 	rc = async_connect_to_me(exch, 0, 0, 0, kbd_port_events, NULL);
 	async_exchange_end(exch);
Index: uspace/srv/hid/input/proto/mousedev.c
===================================================================
--- uspace/srv/hid/input/proto/mousedev.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/hid/input/proto/mousedev.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -117,5 +117,5 @@
 		printf("%s: Failed starting session with '%s'\n", NAME,
 		    mdev->svc_name);
-		return ENOENT;
+		return -1;
 	}
 	
@@ -125,5 +125,5 @@
 		    NAME, mdev->svc_name);
 		async_hangup(sess);
-		return ENOMEM;
+		return -1;
 	}
 	
@@ -134,5 +134,5 @@
 		mousedev_destroy(mousedev);
 		async_hangup(sess);
-		return ENOENT;
+		return -1;
 	}
 	
@@ -145,8 +145,8 @@
 		    NAME, mdev->svc_name);
 		mousedev_destroy(mousedev);
-		return rc;
+		return -1;
 	}
 	
-	return EOK;
+	return 0;
 }
 
Index: uspace/srv/hid/remcons/remcons.c
===================================================================
--- uspace/srv/hid/remcons/remcons.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/hid/remcons/remcons.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -71,5 +71,4 @@
 	TELNET_IAC, TELNET_WONT, TELNET_LINEMODE
 };
-
 static const size_t telnet_force_character_mode_command_count =
     sizeof(telnet_force_character_mode_command) / sizeof(telnet_cmd_t);
@@ -273,7 +272,8 @@
 static int network_user_fibril(void *arg)
 {
+	int rc;
 	telnet_user_t *user = arg;
 
-	int rc = loc_service_register(user->service_name, &user->service_id);
+	rc = loc_service_register(user->service_name, &user->service_id);
 	if (rc != EOK) {
 		telnet_user_error(user, "Unable to register %s with loc: %s.",
@@ -284,9 +284,9 @@
 	telnet_user_log(user, "Service %s registerd with id %" PRIun ".",
 	    user->service_name, user->service_id);
-	
+
 	fid_t spawn_fibril = fibril_create(spawn_task_fibril, user);
 	assert(spawn_fibril);
 	fibril_add_ready(spawn_fibril);
-	
+
 	/* Wait for all clients to exit. */
 	fibril_mutex_lock(&user->guard);
@@ -304,5 +304,5 @@
 	}
 	fibril_mutex_unlock(&user->guard);
-	
+
 	rc = loc_service_unregister(user->service_id);
 	if (rc != EOK) {
@@ -324,14 +324,15 @@
 	async_set_client_connection(client_connection);
 	int rc = loc_server_register(NAME);
-	if (rc != EOK) {
-		fprintf(stderr, "%s: Unable to register server\n", NAME);
-		return rc;
-	}
-	
+	if (rc < 0) {
+		fprintf(stderr, NAME ": Unable to register server: %s.\n",
+		    str_error(rc));
+		return 1;
+	}
+
 	struct sockaddr_in addr;
-	
+
 	addr.sin_family = AF_INET;
 	addr.sin_port = htons(port);
-	
+
 	rc = inet_pton(AF_INET, "127.0.0.1", (void *)
 	    &addr.sin_addr.s_addr);
Index: uspace/srv/hid/remcons/user.h
===================================================================
--- uspace/srv/hid/remcons/user.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/hid/remcons/user.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -76,26 +76,24 @@
 } telnet_user_t;
 
-extern telnet_user_t *telnet_user_create(int);
-extern void telnet_user_destroy(telnet_user_t *);
-extern telnet_user_t *telnet_user_get_for_client_connection(service_id_t);
-extern bool telnet_user_is_zombie(telnet_user_t *);
-extern void telnet_user_notify_client_disconnected(telnet_user_t *);
-extern int telnet_user_get_next_keyboard_event(telnet_user_t *, kbd_event_t *);
-extern int telnet_user_send_data(telnet_user_t *, uint8_t *, size_t);
-extern void telnet_user_update_cursor_x(telnet_user_t *, int);
+telnet_user_t *telnet_user_create(int socket);
+void telnet_user_destroy(telnet_user_t *user);
+telnet_user_t *telnet_user_get_for_client_connection(service_id_t id);
+bool telnet_user_is_zombie(telnet_user_t *user);
+void telnet_user_notify_client_disconnected(telnet_user_t *user);
+int telnet_user_get_next_keyboard_event(telnet_user_t *user, kbd_event_t *event);
+int telnet_user_send_data(telnet_user_t *user, uint8_t *data, size_t size);
+void telnet_user_update_cursor_x(telnet_user_t *user, int new_x);
 
 /** Print informational message about connected user. */
 #ifdef CONFIG_DEBUG
 #define telnet_user_log(user, fmt, ...) \
-	printf(NAME " [console %d (%d)]: " fmt "\n", \
-	    user->id, (int) user->service_id, ##__VA_ARGS__)
+	printf(NAME " [console %d (%d)]: " fmt "\n", user->id, (int) user->service_id, ##__VA_ARGS__)
 #else
-#define telnet_user_log(user, fmt, ...) ((void) 0)
+#define telnet_user_log(user, fmt, ...) (void)0
 #endif
 
 /** Print error message associated with connected user. */
 #define telnet_user_error(user, fmt, ...) \
-	fprintf(stderr, NAME " [console %d (%d)]: ERROR: " fmt "\n", \
-	    user->id, (int) user->service_id, ##__VA_ARGS__)
+	fprintf(stderr, NAME " [console %d (%d)]: ERROR: " fmt "\n", user->id, (int) user->service_id, ##__VA_ARGS__)
 
 #endif
Index: uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c
===================================================================
--- uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -84,11 +84,13 @@
 int main(int argc, char *argv[])
 {
-	printf("%s: S3C24xx touchscreen driver\n", NAME);
+	int rc;
+
+	printf(NAME ": S3C24xx touchscreen driver\n");
 	
 	async_set_client_connection(s3c24xx_ts_connection);
-	int rc = loc_server_register(NAME);
-	if (rc != EOK) {
-		printf("%s: Unable to register driver.\n", NAME);
-		return rc;
+	rc = loc_server_register(NAME);
+	if (rc < 0) {
+		printf(NAME ": Unable to register driver.\n");
+		return -1;
 	}
 
Index: uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c
===================================================================
--- uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -77,11 +77,13 @@
 int main(int argc, char *argv[])
 {
-	printf("%s: S3C24xx on-chip UART driver\n", NAME);
-	
+	int rc;
+
+	printf(NAME ": S3C24xx on-chip UART driver\n");
+
 	async_set_client_connection(s3c24xx_uart_connection);
-	int rc = loc_server_register(NAME);
-	if (rc != EOK) {
-		printf("%s: Unable to register server.\n", NAME);
-		return rc;
+	rc = loc_server_register(NAME);
+	if (rc < 0) {
+		printf(NAME ": Unable to register server.\n");
+		return -1;
 	}
 
Index: uspace/srv/loader/main.c
===================================================================
--- uspace/srv/loader/main.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/loader/main.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -450,10 +450,9 @@
 	int rc = ns_intro(id);
 	if (rc != EOK)
-		return rc;
+		return -1;
 	
 	/* Register at naming service. */
-	rc = service_register(SERVICE_LOAD);
-	if (rc != EOK)
-		return rc;
+	if (service_register(SERVICE_LOAD) != EOK)
+		return -2;
 	
 	async_manager();
Index: uspace/srv/locsrv/locsrv.c
===================================================================
--- uspace/srv/locsrv/locsrv.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/locsrv/locsrv.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -390,4 +390,5 @@
 	 */
 	list_initialize(&server->services);
+
 	link_initialize(&server->servers);
 	
@@ -650,50 +651,4 @@
 	    min(size, act_size));
 	free(fqn);
-	
-	fibril_mutex_unlock(&services_list_mutex);
-	
-	async_answer_0(iid, retval);
-}
-
-static void loc_service_get_server_name(ipc_callid_t iid, ipc_call_t *icall)
-{
-	ipc_callid_t callid;
-	size_t size;
-	size_t act_size;
-	loc_service_t *svc;
-	
-	if (!async_data_read_receive(&callid, &size)) {
-		async_answer_0(callid, EREFUSED);
-		async_answer_0(iid, EREFUSED);
-		return;
-	}
-	
-	fibril_mutex_lock(&services_list_mutex);
-	
-	svc = loc_service_find_id(IPC_GET_ARG1(*icall));
-	if (svc == NULL) {
-		fibril_mutex_unlock(&services_list_mutex);
-		async_answer_0(callid, ENOENT);
-		async_answer_0(iid, ENOENT);
-		return;
-	}
-	
-	if (svc->server == NULL) {
-		fibril_mutex_unlock(&services_list_mutex);
-		async_answer_0(callid, EINVAL);
-		async_answer_0(iid, EINVAL);
-		return;
-	}
-	
-	act_size = str_size(svc->server->name);
-	if (act_size > size) {
-		fibril_mutex_unlock(&services_list_mutex);
-		async_answer_0(callid, EOVERFLOW);
-		async_answer_0(iid, EOVERFLOW);
-		return;
-	}
-	
-	sysarg_t retval = async_data_read_finalize(callid, svc->server->name,
-	    min(size, act_size));
 	
 	fibril_mutex_unlock(&services_list_mutex);
@@ -1451,7 +1406,4 @@
 			loc_service_get_name(callid, &call);
 			break;
-		case LOC_SERVICE_GET_SERVER_NAME:
-			loc_service_get_server_name(callid, &call);
-			break;
 		case LOC_NAMESPACE_GET_ID:
 			loc_namespace_get_id(callid, &call);
@@ -1538,7 +1490,6 @@
 	
 	/* Register location service at naming service */
-	int rc = service_register(SERVICE_LOC);
-	if (rc != EOK)
-		return rc;
+	if (service_register(SERVICE_LOC) != EOK)
+		return -1;
 	
 	printf("%s: Accepting connections\n", NAME);
Index: uspace/srv/net/ethip/ethip.c
===================================================================
--- uspace/srv/net/ethip/ethip.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/net/ethip/ethip.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -73,16 +73,18 @@
 static int ethip_init(void)
 {
+	int rc;
+
 	async_set_client_connection(ethip_client_conn);
-	
-	int rc = loc_server_register(NAME);
+
+	rc = loc_server_register(NAME);
 	if (rc != EOK) {
 		log_msg(LVL_ERROR, "Failed registering server.");
 		return rc;
 	}
-	
+
 	rc = ethip_nic_discovery_start();
 	if (rc != EOK)
 		return rc;
-	
+
 	return EOK;
 }
Index: uspace/srv/net/ethip/ethip_nic.c
===================================================================
--- uspace/srv/net/ethip/ethip_nic.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/net/ethip/ethip_nic.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -150,18 +150,20 @@
 static int ethip_nic_open(service_id_t sid)
 {
+	ethip_nic_t *nic;
+	int rc;
 	bool in_list = false;
 	nic_address_t nic_address;
-	
+
 	log_msg(LVL_DEBUG, "ethip_nic_open()");
-	ethip_nic_t *nic = ethip_nic_new();
+	nic = ethip_nic_new();
 	if (nic == NULL)
 		return ENOMEM;
-	
-	int rc = loc_service_get_name(sid, &nic->svc_name);
+
+	rc = loc_service_get_name(sid, &nic->svc_name);
 	if (rc != EOK) {
 		log_msg(LVL_ERROR, "Failed getting service name.");
 		goto error;
 	}
-	
+
 	nic->sess = loc_service_connect(EXCHANGE_SERIALIZE, sid, 0);
 	if (nic->sess == NULL) {
@@ -169,7 +171,7 @@
 		goto error;
 	}
-	
+
 	nic->svc_id = sid;
-	
+
 	rc = nic_callback_create(nic->sess, ethip_nic_cb_conn, nic);
 	if (rc != EOK) {
@@ -296,5 +298,7 @@
 int ethip_nic_discovery_start(void)
 {
-	int rc = loc_register_cat_change_cb(ethip_nic_cat_change_cb);
+	int rc;
+
+	rc = loc_register_cat_change_cb(ethip_nic_cat_change_cb);
 	if (rc != EOK) {
 		log_msg(LVL_ERROR, "Failed registering callback for NIC "
@@ -302,5 +306,5 @@
 		return rc;
 	}
-	
+
 	return ethip_nic_check_new();
 }
Index: uspace/srv/net/inetsrv/inetsrv.c
===================================================================
--- uspace/srv/net/inetsrv/inetsrv.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/net/inetsrv/inetsrv.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -66,15 +66,17 @@
 static int inet_init(void)
 {
+	service_id_t sid;
+	int rc;
+
 	log_msg(LVL_DEBUG, "inet_init()");
-	
+
 	async_set_client_connection(inet_client_conn);
-	
-	int rc = loc_server_register(NAME);
+
+	rc = loc_server_register(NAME);
 	if (rc != EOK) {
 		log_msg(LVL_ERROR, "Failed registering server (%d).", rc);
 		return EEXIST;
 	}
-	
-	service_id_t sid;
+
 	rc = loc_service_register_with_iface(SERVICE_NAME_INET, &sid,
 	    INET_PORT_DEFAULT);
@@ -83,5 +85,5 @@
 		return EEXIST;
 	}
-	
+
 	rc = loc_service_register_with_iface(SERVICE_NAME_INETCFG, &sid,
 	    INET_PORT_CFG);
@@ -90,5 +92,5 @@
 		return EEXIST;
 	}
-	
+
 	rc = loc_service_register_with_iface(SERVICE_NAME_INETPING, &sid,
 	    INET_PORT_PING);
@@ -97,9 +99,9 @@
 		return EEXIST;
 	}
-	
+
 	rc = inet_link_discovery_start();
 	if (rc != EOK)
 		return EEXIST;
-	
+
 	return EOK;
 }
Index: uspace/srv/net/tcp/sock.c
===================================================================
--- uspace/srv/net/tcp/sock.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/net/tcp/sock.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -68,12 +68,14 @@
 int tcp_sock_init(void)
 {
+	int rc;
+
 	socket_ports_initialize(&gsock);
-	
+
 	async_set_client_connection(tcp_sock_connection);
-	
-	int rc = service_register(SERVICE_TCP);
+
+	rc = service_register(SERVICE_TCP);
 	if (rc != EOK)
 		return EEXIST;
-	
+
 	return EOK;
 }
@@ -151,9 +153,6 @@
 	    sock, sock_id);
 
-	if (rc != EOK) {
-		fibril_destroy(sock->recv_fibril);
-		sock->recv_fibril = 0;
+	if (rc != EOK)
 		return rc;
-	}
 
 	sock_core = socket_cores_find(&sock->client->sockets, *sock_id);
Index: uspace/srv/net/udp/sock.c
===================================================================
--- uspace/srv/net/udp/sock.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/net/udp/sock.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -51,4 +51,6 @@
 #include "ucall.h"
 
+#define FRAGMENT_SIZE 1024
+
 /** Free ports pool start. */
 #define UDP_FREE_PORTS_START		1025
@@ -61,16 +63,17 @@
 
 static void udp_sock_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg);
-static int udp_sock_recv_fibril(void *arg);
 
 int udp_sock_init(void)
 {
+	int rc;
+
 	socket_ports_initialize(&gsock);
-	
+
 	async_set_client_connection(udp_sock_connection);
-	
-	int rc = service_register(SERVICE_UDP);
+
+	rc = service_register(SERVICE_UDP);
 	if (rc != EOK)
 		return EEXIST;
-	
+
 	return EOK;
 }
@@ -81,7 +84,6 @@
 
 	socket = (udp_sockdata_t *)sock_core->specific_data;
-	(void)socket;
-
-	/* XXX We need to force the receive fibril to quit */
+	assert(socket->assoc != NULL);
+	udp_uc_destroy(socket->assoc);
 }
 
@@ -91,5 +93,5 @@
 	async_exch_t *exch = async_exchange_begin(sock_core->sess);
 	async_msg_5(exch, NET_SOCKET_RECEIVED, (sysarg_t)sock_core->socket_id,
-	    UDP_FRAGMENT_SIZE, 0, 0, 1);
+	    FRAGMENT_SIZE, 0, 0, 1);
 	async_exchange_end(exch);
 }
@@ -113,21 +115,9 @@
 	sock->client = client;
 
-	sock->recv_buffer_used = 0;
-	sock->recv_error = UDP_EOK;
-	fibril_mutex_initialize(&sock->recv_buffer_lock);
-	fibril_condvar_initialize(&sock->recv_buffer_cv);
-
 	rc = udp_uc_create(&sock->assoc);
 	if (rc != EOK) {
+		udp_uc_destroy(sock->assoc);
 		free(sock);
 		async_answer_0(callid, rc);
-		return;
-	}
-
-	sock->recv_fibril = fibril_create(udp_sock_recv_fibril, sock);
-	if (sock->recv_fibril == 0) {
-		udp_uc_destroy(sock->assoc);
-		free(sock);
-		async_answer_0(callid, ENOMEM);
 		return;
 	}
@@ -136,12 +126,7 @@
 	rc = socket_create(&client->sockets, client->sess, sock, &sock_id);
 	if (rc != EOK) {
-		fibril_destroy(sock->recv_fibril);
-		udp_uc_destroy(sock->assoc);
-		free(sock);
 		async_answer_0(callid, rc);
 		return;
 	}
-
-	fibril_add_ready(sock->recv_fibril);
 
 	sock_core = socket_cores_find(&client->sockets, sock_id);
@@ -151,5 +136,5 @@
 	SOCKET_SET_SOCKET_ID(answer, sock_id);
 
-	SOCKET_SET_DATA_FRAGMENT_SIZE(answer, UDP_FRAGMENT_SIZE);
+	SOCKET_SET_DATA_FRAGMENT_SIZE(answer, FRAGMENT_SIZE);
 	SOCKET_SET_HEADER_SIZE(answer, sizeof(udp_header_t));
 	async_answer_3(callid, EOK, IPC_GET_ARG1(answer),
@@ -222,4 +207,6 @@
 	}
 
+	udp_sock_notify_data(sock_core);
+
 	log_msg(LVL_DEBUG, " - success");
 	async_answer_0(callid, rc);
@@ -260,5 +247,5 @@
 	ipc_callid_t wcallid;
 	size_t length;
-	uint8_t buffer[UDP_FRAGMENT_SIZE];
+	uint8_t buffer[FRAGMENT_SIZE];
 	udp_error_t urc;
 	int rc;
@@ -307,4 +294,6 @@
 			goto out;
 		}
+
+		udp_sock_notify_data(sock_core);
 	}
 
@@ -343,6 +332,6 @@
 		}
 
-		if (length > UDP_FRAGMENT_SIZE)
-			length = UDP_FRAGMENT_SIZE;
+		if (length > FRAGMENT_SIZE)
+			length = FRAGMENT_SIZE;
 
 		rc = async_data_write_finalize(wcallid, buffer, length);
@@ -380,5 +369,5 @@
 	
 	IPC_SET_ARG1(answer, 0);
-	SOCKET_SET_DATA_FRAGMENT_SIZE(answer, UDP_FRAGMENT_SIZE);
+	SOCKET_SET_DATA_FRAGMENT_SIZE(answer, FRAGMENT_SIZE);
 	async_answer_2(callid, EOK, IPC_GET_ARG1(answer),
 	    IPC_GET_ARG2(answer));
@@ -399,8 +388,10 @@
 	ipc_call_t answer;
 	ipc_callid_t rcallid;
+	uint8_t buffer[FRAGMENT_SIZE];
 	size_t data_len;
+	xflags_t xflags;
 	udp_error_t urc;
+	struct sockaddr_in addr;
 	udp_sock_t rsock;
-	struct sockaddr_in addr;
 	int rc;
 
@@ -427,19 +418,7 @@
 	(void)flags;
 
-	log_msg(LVL_DEBUG, "udp_sock_recvfrom(): lock recv_buffer lock");
-	fibril_mutex_lock(&socket->recv_buffer_lock);
-	while (socket->recv_buffer_used == 0 && socket->recv_error == UDP_EOK) {
-		log_msg(LVL_DEBUG, "udp_sock_recvfrom(): wait for cv");
-		fibril_condvar_wait(&socket->recv_buffer_cv,
-		    &socket->recv_buffer_lock);
-	}
-
-	log_msg(LVL_DEBUG, "Got data in sock recv_buffer");
-
-	rsock = socket->recv_fsock;
-	data_len = socket->recv_buffer_used;
-	urc = socket->recv_error;
-
-	log_msg(LVL_DEBUG, "**** recv data_len=%zu", data_len);
+	urc = udp_uc_receive(socket->assoc, buffer, FRAGMENT_SIZE, &data_len,
+	    &xflags, &rsock);
+	log_msg(LVL_DEBUG, "**** udp_uc_receive done, data_len=%zu", data_len);
 
 	switch (urc) {
@@ -460,5 +439,4 @@
 	log_msg(LVL_DEBUG, "**** udp_uc_receive -> %d", rc);
 	if (rc != EOK) {
-		fibril_mutex_unlock(&socket->recv_buffer_lock);
 		fibril_mutex_unlock(&socket->lock);
 		async_answer_0(callid, rc);
@@ -474,5 +452,4 @@
 		log_msg(LVL_DEBUG, "addr read receive");
 		if (!async_data_read_receive(&rcallid, &addr_length)) {
-			fibril_mutex_unlock(&socket->recv_buffer_lock);
 			fibril_mutex_unlock(&socket->lock);
 			async_answer_0(callid, EINVAL);
@@ -486,5 +463,4 @@
 		rc = async_data_read_finalize(rcallid, &addr, addr_length);
 		if (rc != EOK) {
-			fibril_mutex_unlock(&socket->recv_buffer_lock);
 			fibril_mutex_unlock(&socket->lock);
 			async_answer_0(callid, EINVAL);
@@ -495,5 +471,4 @@
 	log_msg(LVL_DEBUG, "data read receive");
 	if (!async_data_read_receive(&rcallid, &length)) {
-		fibril_mutex_unlock(&socket->recv_buffer_lock);
 		fibril_mutex_unlock(&socket->lock);
 		async_answer_0(callid, EINVAL);
@@ -505,5 +480,5 @@
 
 	log_msg(LVL_DEBUG, "data read finalize");
-	rc = async_data_read_finalize(rcallid, socket->recv_buffer, length);
+	rc = async_data_read_finalize(rcallid, buffer, length);
 
 	if (length < data_len && rc == EOK)
@@ -516,9 +491,7 @@
 	async_answer_3(callid, EOK, IPC_GET_ARG1(answer),
 	    IPC_GET_ARG2(answer), IPC_GET_ARG3(answer));
-
-	socket->recv_buffer_used = 0;
-
-	fibril_condvar_broadcast(&socket->recv_buffer_cv);
-	fibril_mutex_unlock(&socket->recv_buffer_lock);
+	
+	/* Push one fragment notification to client's queue */
+	udp_sock_notify_data(sock_core);
 	fibril_mutex_unlock(&socket->lock);
 }
@@ -567,46 +540,4 @@
 }
 
-static int udp_sock_recv_fibril(void *arg)
-{
-	udp_sockdata_t *sock = (udp_sockdata_t *)arg;
-	udp_error_t urc;
-	xflags_t xflags;
-	size_t rcvd;
-
-	log_msg(LVL_DEBUG, "udp_sock_recv_fibril()");
-
-	while (true) {
-		log_msg(LVL_DEBUG, "[] wait for rcv buffer empty()");
-		fibril_mutex_lock(&sock->recv_buffer_lock);
-		while (sock->recv_buffer_used != 0) {
-			fibril_condvar_wait(&sock->recv_buffer_cv,
-			    &sock->recv_buffer_lock);
-		}
-
-		log_msg(LVL_DEBUG, "[] call udp_uc_receive()");
-		urc = udp_uc_receive(sock->assoc, sock->recv_buffer,
-		    UDP_FRAGMENT_SIZE, &rcvd, &xflags, &sock->recv_fsock);
-		sock->recv_error = urc;
-
-		udp_sock_notify_data(sock->sock_core);
-
-		if (urc != UDP_EOK) {
-			fibril_condvar_broadcast(&sock->recv_buffer_cv);
-			fibril_mutex_unlock(&sock->recv_buffer_lock);
-			break;
-		}
-
-		log_msg(LVL_DEBUG, "[] got data - broadcast recv_buffer_cv");
-
-		sock->recv_buffer_used = rcvd;
-		fibril_mutex_unlock(&sock->recv_buffer_lock);
-		fibril_condvar_broadcast(&sock->recv_buffer_cv);
-	}
-
-	udp_uc_destroy(sock->assoc);
-
-	return 0;
-}
-
 static void udp_sock_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg)
 {
Index: uspace/srv/net/udp/udp.c
===================================================================
--- uspace/srv/net/udp/udp.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/net/udp/udp.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -73,5 +73,5 @@
 	printf(NAME ": UDP (User Datagram Protocol) service\n");
 
-	rc = log_init(NAME, LVL_DEBUG);
+	rc = log_init(NAME, LVL_WARN);
 	if (rc != EOK) {
 		printf(NAME ": Failed to initialize log.\n");
Index: uspace/srv/net/udp/udp_type.h
===================================================================
--- uspace/srv/net/udp/udp_type.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/net/udp/udp_type.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -36,11 +36,7 @@
 #define UDP_TYPE_H
 
-#include <fibril.h>
 #include <fibril_synch.h>
 #include <socket_core.h>
 #include <sys/types.h>
-
-#define UDP_FRAGMENT_SIZE 4096
-
 
 typedef enum {
@@ -145,12 +141,4 @@
 	/** Connection */
 	udp_assoc_t *assoc;
-	/** Receiving fibril */
-	fid_t recv_fibril;
-	uint8_t recv_buffer[UDP_FRAGMENT_SIZE];
-	size_t recv_buffer_used;
-	udp_sock_t recv_fsock;
-	fibril_mutex_t recv_buffer_lock;
-	fibril_condvar_t recv_buffer_cv;
-	udp_error_t recv_error;
 } udp_sockdata_t;
 
Index: uspace/srv/ns/ns.c
===================================================================
--- uspace/srv/ns/ns.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/ns/ns.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -48,5 +48,5 @@
 int main(int argc, char **argv)
 {
-	printf("%s: HelenOS IPC Naming Service\n", NAME);
+	printf(NAME ": HelenOS IPC Naming Service\n");
 	
 	int rc = service_init();
Index: uspace/srv/vfs/vfs.c
===================================================================
--- uspace/srv/vfs/vfs.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ uspace/srv/vfs/vfs.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -159,5 +159,5 @@
 int main(int argc, char **argv)
 {
-	printf("%s: HelenOS VFS server\n", NAME);
+	printf(NAME ": HelenOS VFS server\n");
 	
 	/*
@@ -165,6 +165,5 @@
 	 */
 	if (!vfs_nodes_init()) {
-		printf("%s: Failed to initialize VFS node hash table\n",
-		    NAME);
+		printf(NAME ": Failed to initialize VFS node hash table\n");
 		return ENOMEM;
 	}
@@ -173,8 +172,8 @@
 	 * Allocate and initialize the Path Lookup Buffer.
 	 */
-	plb = as_area_create(AS_AREA_ANY, PLB_SIZE,
+	plb = as_area_create((void *) -1, PLB_SIZE,
 	    AS_AREA_READ | AS_AREA_WRITE | AS_AREA_CACHEABLE);
-	if (plb == AS_MAP_FAILED) {
-		printf("%s: Cannot create address space area\n", NAME);
+	if (plb == (void *) -1) {
+		printf(NAME ": Cannot create address space area\n");
 		return ENOMEM;
 	}
@@ -197,12 +196,11 @@
 	async_set_interrupt_received(notification_received);
 	event_task_subscribe(EVENT_TASK_STATE_CHANGE, VFS_TASK_STATE_CHANGE);
-	
+
 	/*
 	 * Register at the naming service.
 	 */
-	int rc = service_register(SERVICE_VFS);
-	if (rc != EOK) {
+	if (service_register(SERVICE_VFS) != EOK) {
 		printf("%s: Cannot register VFS service\n", NAME);
-		return rc;
+		return EINVAL;
 	}
 	
@@ -210,5 +208,5 @@
 	 * Start accepting connections.
 	 */
-	printf("%s: Accepting connections\n", NAME);
+	printf(NAME ": Accepting connections\n");
 	async_manager();
 	return 0;
